<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Chapitre 2. Premiers pas</title>
    <link rel="stylesheet" type="text/css" href="debian.css"/>
    <meta name="generator" content="DocBook XSL Stylesheets V1.78.1"/>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <link rel="home" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="up" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="prev" href="start.fr.html" title="Chapitre 1. Partir du bon pied"/>
    <link rel="next" href="modify.fr.html" title="Chapitre 3. Modification du code source"/>
  </head>
  <body>
    <div class="navheader">
      <table width="100%" summary="Navigation header">
        <tr>
          <th colspan="3" align="center">Chapitre 2. Premiers pas</th>
        </tr>
        <tr>
          <td align="left"><a accesskey="p" href="start.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <th width="60%" align="center"> </th>
          <td align="right"> <a accesskey="n" href="modify.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
      </table>
      <hr/>
    </div>
    <div class="chapter">
      <div class="titlepage">
        <div>
          <div>
            <h1 class="title"><a id="first"/>Chapitre 2. Premiers pas</h1>
          </div>
        </div>
      </div>
      <div class="toc">
        <p>
          <strong>Table des matières</strong>
        </p>
        <dl class="toc">
          <dt>
            <span class="section">
              <a href="first.fr.html#workflow">2.1. Processus de construction de paquet Debian</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="first.fr.html#choose">2.2. Choix du programme</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="first.fr.html#getit">2.3. Obtenir le programme et l'essayer</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="first.fr.html#simplemake">2.4. Systèmes de construction simples</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="first.fr.html#portable">2.5. Systèmes de construction portables répandus</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="first.fr.html#namever">2.6. Nom et version de paquet</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="first.fr.html#dh-make">2.7. Configuration de <span class="command"><strong>dh_make</strong></span></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="first.fr.html#non-native-dh-make">2.8. Paquet Debian non natif initial</a>
            </span>
          </dt>
        </dl>
      </div>
      <p>
Commencez par créer votre propre paquet (ou, encore mieux, par en adopter
un).
</p>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="workflow"/>2.1. Processus de construction de paquet Debian</h2>
            </div>
          </div>
        </div>
        <p>
Si vous faites un paquet Debian à partir d'un programme amont, le processus
typique de construction de paquet Debian implique de créer plusieurs
fichiers au nom spécifique pour chaque étape comme suit :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>obtenir une copie du logiciel amont, généralement distribuée sous la forme
d'un fichier au format tar compressé :</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <code class="literal"><em class="replaceable"><code>paquet</code></em>-<em class="replaceable"><code>version</code></em>.tar.gz</code>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>
ajouter les modifications spécifiques à Debian au programme amont dans le
répertoire <code class="filename">debian</code>, et créer un paquet source non natif
(c'est-à-dire, le jeu de fichiers d'entrée utilisés pour la construction du
paquet Debian) au format <code class="literal">3.0 (quilt)</code> :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <code class="literal"><em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>.tar.gz</code>
                  </li>
                  <li class="listitem">
                    <code class="literal"><em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>-<em class="replaceable"><code>révision</code></em>.debian.tar.gz</code>
                    <a href="#ftn.idp38423440" class="footnote" id="idp38423440">
                      <sup class="footnote">[4]</sup>
                    </a>
                  </li>
                  <li class="listitem">
                    <code class="literal"><em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>-<em class="replaceable"><code>révision</code></em>.dsc</code>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>
construire les paquets binaires Debian, qui sont des fichiers de paquet
installable classique au format <code class="literal">.deb</code> (ou
<code class="literal">.udeb</code> pour l'installateur Debian) à partir du paquet
source Debian :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <code class="literal"><em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>-<em class="replaceable"><code>révision</code></em>_<em class="replaceable"><code>arch</code></em>.deb</code>
                  </li>
                </ul>
              </div>
            </li>
          </ul>
        </div>
        <p>
Veuillez remarquer que le caractère séparant
<code class="literal"><em class="replaceable"><code>paquet</code></em></code> de
<code class="literal"><em class="replaceable"><code>version</code></em></code> a été modifié : le
tiret (<code class="literal">-</code>) dans le nom de l'archive source a été remplacée
par un tiret bas (<code class="literal">_</code>) dans les noms de fichier de paquet
Debian.
</p>
        <p>
Dans les noms de fichier précédents, la partie
<code class="literal"><em class="replaceable"><code>paquet</code></em></code> du nom de fichier est
remplacé par le <span class="strong"><strong>nom du paquet</strong></span>, la partie
<code class="literal"><em class="replaceable"><code>version</code></em></code> par la <span class="strong"><strong>version amont</strong></span>, la partie
<code class="literal"><em class="replaceable"><code>révision</code></em></code> par la <span class="strong"><strong>révision Debian</strong></span> et la partie
<code class="literal"><em class="replaceable"><code>arch</code></em></code> par l'<span class="strong"><strong>architecture du paquet</strong></span>, conformément à la Charte
Debian. <a href="#ftn.idp38440064" class="footnote" id="idp38440064"><sup class="footnote">[5]</sup></a>
</p>
        <p>
Chaque étape de ces grandes lignes sera expliquée avec des exemples
détaillés dans les sections suivantes.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="choose"/>2.2. Choix du programme</h2>
            </div>
          </div>
        </div>
        <p>
Vous avez probablement choisi le paquet que vous voulez créer.  La première
chose à faire est de vérifier si le paquet ne se trouve pas déjà dans
l'archive de la distribution en utilisant ce qui suit :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>la commande <span class="command"><strong>aptitude</strong></span> ;</p>
            </li>
            <li class="listitem">
              <p>la page des <a class="ulink" href="http://www.debian.org/distrib/packages">paquets Debian</a> ;</p>
            </li>
            <li class="listitem">
              <p>la page du <a class="ulink" href="http://packages.qa.debian.org/common/index.html">système de suivi de paquets
Debian</a>.</p>
            </li>
          </ul>
        </div>
        <p>
Si le paquet existe déjà, et bien, installez-le :-). S'il se trouve qu'il
est <span class="strong"><strong>orphelin</strong></span> (c'est à dire si son
responsable est <a class="ulink" href="http://qa.debian.org/">Debian QA Group</a>), vous devriez
pouvoir le reprendre s'il est toujours disponible. Vous pouvez aussi adopter
un paquet dont le responsable a rempli une demande d'adoption (« Request for
Adoption » ou <span class="strong"><strong>RFA</strong></span>).<a href="#ftn.idp38454432" class="footnote" id="idp38454432"><sup class="footnote">[6]</sup></a>
</p>
        <p>
Plusieurs ressources d'état de propriété de paquet Debian existent :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>La commande <span class="command"><strong>wnpp-alert</strong></span> du paquet <code class="systemitem">devscripts</code> ;</p>
            </li>
            <li class="listitem">
              <p> <a class="ulink" href="http://www.debian.org/devel/wnpp/">liste des paquets en souffrance et paquets
souhaités</a> ; </p>
            </li>
            <li class="listitem">
              <p> <a class="ulink" href="http://bugs.debian.org/wnpp">journal de rapports de bogue Debian : bogues du
pseudo-paquet <code class="systemitem">wnpp</code> dans
<code class="literal">unstable</code></a> ; </p>
            </li>
            <li class="listitem">
              <p> <a class="ulink" href="http://wnpp.debian.net/">paquets Debian en manque d'amour</a> ; </p>
            </li>
            <li class="listitem">
              <p> <a class="ulink" href="http://wnpp-by-tags.debian.net/">naviguer parmi les bogues <code class="systemitem">wnpp</code> en fonction des debtags</a>. </p>
            </li>
          </ul>
        </div>
        <p>
En remarque, il est important de souligner que Debian possède déjà des
paquets pour quasiment tous les types de programme, et que le nombre de
paquets déjà dans l'archive Debian est bien plus important que le nombre de
personnes ayant les droits suffisants pour envoyer les mises à jour. Par
conséquent, contribuer aux paquets existants déjà dans l'archive est bien
plus apprécié (avec plus de chances d'être parrainé) des autres développeurs
<a href="#ftn.idp38467536" class="footnote" id="idp38467536"><sup class="footnote">[7]</sup></a>. Il est possible de contribuer de
plusieurs façons comme suit :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
se charger de paquets orphelins, encore largement utilisés ;
</p>
            </li>
            <li class="listitem">
              <p>
rejoindre des <a class="ulink" href="http://wiki.debian.org/Teams">équipes d'empaquetage</a> ;
</p>
            </li>
            <li class="listitem">
              <p>
trier des bogues de paquets populaires ;
</p>
            </li>
            <li class="listitem">
              <p>
préparer des <a class="ulink" href="http://www.debian.org/doc/developers-reference/pkgs.html#nmu-qa-upload">envois de QA ou des NMU</a>.
</p>
            </li>
          </ul>
        </div>
        <p>
Si vous pouvez adopter le paquet, récupérez les sources (avec quelque chose
comme <code class="literal">apt-get source
<em class="replaceable"><code>nomdepaquet</code></em></code>) et
examinez-les. Malheureusement ce document n'inclut pas d'informations
exhaustives sur l'adoption de paquets. Heureusement, vous ne devriez pas
avoir de problèmes à comprendre comment le paquet fonctionne, puisque
quelqu'un s'est déjà occupé de la configuration initiale pour
vous. Continuez quand même à lire ce document, une bonne partie des conseils
qui suivent seront applicables dans votre cas.
</p>
        <p>
Si le paquet est nouveau, et que vous aimeriez le voir dans Debian, procédez
comme suit :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
d'abord, assurez-vous que le programme fonctionne, et essayez-le pendant
quelques temps pour confirmer son utilité ;
</p>
            </li>
            <li class="listitem">
              <p>
vérifiez que personne d'autre ne travaille déjà sur ce paquet en consultant
la <a class="ulink" href="http://www.debian.org/devel/wnpp/">liste des paquets en souffrance et paquets
souhaités</a>. Si personne ne travaille dessus, déclarez votre intention
de l'empaqueter (« Intent To Package » ou ITP) avec un bogue ITP sur le
pseudo-paquet <code class="systemitem">wnpp</code> en utilisant
<span class="command"><strong>reportbug</strong></span>. Si quelqu'un travaille déjà dessus,
contactez-le si vous voulez. Sinon, trouvez un autre programme intéressant
dont personne ne s'occupe ;
</p>
            </li>
            <li class="listitem">
              <p>
le logiciel <span class="strong"><strong>doit</strong></span> avoir une licence :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>
pour la section <code class="literal">main</code> (principale), la Charte Debian exige
qu'il <span class="strong"><strong>soit totalement conforme aux principes du
logiciel libre selon Debian</strong></span> (« Debian Free Software Guidelines »
ou <a class="ulink" href="http://www.debian.org/social_contract#guidelines">DFSG</a>) et qu’<span class="strong"><strong>il ne
dépende pas de paquets hors de <code class="literal">main</code></strong></span> pour la
compilation ou l'exécution. C'est le cas idéal ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
pour la section <code class="literal">contrib</code> (contributions), il doit être
conforme à tous les DFSG mais peut dépendre de paquets hors de
<code class="literal">main</code> pour la compilation ou l'exécution ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
pour la section <code class="literal">non-free</code> (non libre), il peut être non
conforme aux DFSG mais <span class="strong"><strong>doit être
distribuable</strong></span> ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
en cas de doute sur la section à laquelle il devrait appartenir, envoyez la
licence sur <a class="ulink" href="http://lists.debian.org/debian-legal/">debian-legal@lists.debian.org</a> et demandez
conseil ;
</p>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>
le programme ne devrait <span class="strong"><strong>pas</strong></span> introduire
dans Debian de problèmes relatifs à la sécurité et à la maintenance :
</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>
le programme devrait être bien documenté, et le code doit être
compréhensible (c'est-à-dire, pas volontairement obscur) ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
vous devriez contacter les auteurs du programme pour vérifier qu'ils sont
d'accord pour la création du paquet et bienveillants envers Debian. Il est
important de pouvoir consulter les auteurs en cas de problèmes spécifiques
au programme, n'essayez donc pas de créer un paquet à partir d'un logiciel
non maintenu ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
le programme ne devrait certainement <span class="strong"><strong>pas</strong></span>
être exécuté setuid root, ou encore mieux, il ne devrait pas être setuid ou
setgid pour quoi que ce soit ;
</p>
                  </li>
                  <li class="listitem">
                    <p>
le programme ne devrait ni être un démon, ni s'installer dans un répertoire
<code class="filename">*/sbin</code>, ni ouvrir un port en tant que superutilisateur.
</p>
                  </li>
                </ul>
              </div>
            </li>
          </ul>
        </div>
        <p>
Bien sûr, cette dernière remarque n'est qu'une mesure de sécurité, et n'a
pour but que de vous préserver d'utilisateurs fous de rage si vous faites
une erreur dans un démon setuid… Quand vous aurez plus d'expérience dans la
création de paquets, vous pourrez empaqueter un logiciel de ce type.
</p>
        <p>
En tant que nouveau responsable vous devriez acquérir de l'expérience dans
l'empaquetage de paquets plus faciles plutôt que de créer des paquets
compliqués :  
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>paquets simples :</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>paquet binaire unique, arch = all (collection de données comme par exemple
des fonds d'écran) ;</p>
                  </li>
                  <li class="listitem">
                    <p>paquet binaire unique, arch = all (exécutables écrits en langage interprété
comme le shell POSIX) ;</p>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>paquet de complexité intermédiaire :</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>paquet binaire unique, arch = any (exécutables binaires ELF provenant de
langages comme C ou C++) ;</p>
                  </li>
                  <li class="listitem">
                    <p>plusieurs paquets binaires, arch = any + all (paquets pour exécutables
binaires ELF et documentation) ;</p>
                  </li>
                  <li class="listitem">
                    <p>sources amont dans un autre format que <code class="filename">tar.gz</code> ou
<code class="filename">tar.bz2</code> ;</p>
                  </li>
                  <li class="listitem">
                    <p>sources amont contenant du contenu non distribuable ;</p>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>paquets plus compliqués :</p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>paquet de module interpréteur utilisé par d'autres programmes ;</p>
                  </li>
                  <li class="listitem">
                    <p>paquet de bibliothèque générique ELF utilisé par d'autres paquets ;</p>
                  </li>
                  <li class="listitem">
                    <p>plusieurs paquets binaires dont un paquet de bibliothèque ELF ;</p>
                  </li>
                  <li class="listitem">
                    <p>paquet source avec plusieurs sources amont ;</p>
                  </li>
                  <li class="listitem">
                    <p>paquets de modules du noyau ;</p>
                  </li>
                  <li class="listitem">
                    <p>paquets de correctifs du noyau ;</p>
                  </li>
                  <li class="listitem">
                    <p>paquets avec des scripts du responsable non triviaux.</p>
                  </li>
                </ul>
              </div>
            </li>
          </ul>
        </div>
        <p>
Ce n'est pas si difficile d'empaqueter des paquets plus compliqués, mais
cela exige un peu plus de connaissances. Vous devriez chercher de l'aide
particulière pour chaque fonctionnalité compliquée. Par exemple, certains
langages ont leur propre sous-charte :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p><a class="ulink" href="http://www.debian.org/doc/packaging-manuals/perl-policy/">charte Perl</a> ;</p>
            </li>
            <li class="listitem">
              <p><a class="ulink" href="http://www.debian.org/doc/packaging-manuals/python-policy/">charte Python</a> ;</p>
            </li>
            <li class="listitem">
              <p><a class="ulink" href="http://www.debian.org/doc/packaging-manuals/java-policy/">charte Java</a>.</p>
            </li>
          </ul>
        </div>
        <p>
Un autre vieux proverbe latin s'applique : « <span class="emphasis"><em>fabricando fit
faber</em></span> » (c'est en forgeant que l'on devient forgeron). La
pratique et l'expérience de toutes les étapes de l'empaquetage sont
<span class="emphasis"><em>vivement</em></span> recommandées avec des paquets simples lors de
la lecture de ce tutoriel. Une archive source amont triviale comme
<code class="filename">hello-sh-1.0.tar.gz</code> créée comme suit peut servir de bon
point de départ : <a href="#ftn.idp38521664" class="footnote" id="idp38521664"><sup class="footnote">[8]</sup></a>
</p>
        <pre class="screen">
$ mkdir -p hello-sh/hello-sh-1.0; cd hello-sh/hello-sh-1.0
$ cat &gt; hello &lt;&lt;EOF
#!/bin/sh
# (C) 2011 Truc Bidule, GPL2+
echo "Bonjour !"
EOF
$ chmod 755 hello
$ cd ..
$ tar -cvzf hello-sh-1.0.tar.gz hello-sh-1.0
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="getit"/>2.3. Obtenir le programme et l'essayer</h2>
            </div>
          </div>
        </div>
        <p>
La première chose à faire est de trouver et télécharger le code source
d'origine. Supposons que vous ayez déjà le fichier source pris sur la page
web de l'auteur. Les sources pour les logiciels UNIX libres sont d'habitude
distribués au format <span class="command"><strong>tar</strong></span>+<span class="command"><strong>gzip</strong></span> avec
l'extension <code class="filename">.tar.gz</code>, ou au format
<span class="command"><strong>tar</strong></span>+<span class="command"><strong>bzip2</strong></span> avec l'extension
<code class="filename">.tar.bz2</code>. Elles contiennent normalement un
sous-répertoire nommé
<code class="filename"><em class="replaceable"><code>paquet</code></em>-<em class="replaceable"><code>version</code></em></code>
avec toutes les sources dedans.
</p>
        <p>
Si la dernière version de la source est disponible dans un dépôt de gestion
de version tel que Git, Subversion ou CVS, vous devez la prendre avec
<code class="literal">git clone</code>, <code class="literal">svn co</code>, ou <code class="literal">cvs
co</code> et la compresser vous-même au format
<span class="command"><strong>tar</strong></span>+<span class="command"><strong>gzip</strong></span> avec l'option
<code class="literal">--exclude-vcs</code>.
</p>
        <p>
Si les sources du programme sont disponibles dans un autre format d'archive
(par exemple, le programme se termine par <code class="filename">.Z</code> ou
<code class="filename">.zip</code> <a href="#ftn.idp38537072" class="footnote" id="idp38537072"><sup class="footnote">[9]</sup></a>), vous
devriez le décompresser à l'aide des outils adéquats et le recompresser.
</p>
        <p>
Si le programme est distribué avec du contenu non compatible avec les
principes du logiciel libre selon Debian, vous devriez aussi le décompresser
pour enlever ce contenu et le recompresser avec une version amont modifiée
contenant <code class="literal">dfsg</code>.
</p>
        <p>
Comme exemple, le programme nommé <span class="command"><strong>gentoo</strong></span> (un gestionnaire
de fichiers utilisant GTK+) sera utilisé. <a href="#ftn.idp38540816" class="footnote" id="idp38540816"><sup class="footnote">[10]</sup></a>
</p>
        <p>
Créez un sous-répertoire dans votre répertoire personnel nommé
<code class="filename">debian</code> ou <code class="filename">deb</code> ou quoi que ce soit
d'adéquat (par exemple le nom du programme, <code class="filename">~/gentoo</code>,
ferait l'affaire dans ce cas). Placez l'archive téléchargée dedans, et
décompressez-la avec <code class="literal">tar xzf
gentoo-0.9.12.tar.gz</code>. Assurez-vous qu'aucun message
d'avertissement ne se produit, même <span class="emphasis"><em>sans importance</em></span>,
sinon les outils de décompression d'autres personnes pourraient ne pas gérer
ces problèmes, et être incapables de les décompresser. La ligne de commande
de votre interpréteur devrait ressembler à ceci :
</p>
        <pre class="screen">
$ mkdir ~/gentoo ; cd ~/gentoo
$ wget http://<em class="replaceable"><code>www.example.org</code></em>/gentoo-0.9.12.tar.gz
$ tar xvzf gentoo-0.9.12.tar.gz
$ ls -F
gentoo-0.9.12/
gentoo-0.9.12.tar.gz
</pre>
        <p>
Maintenant vous avez un autre sous-répertoire, nommé
<code class="filename">gentoo-0.9.12</code>. Allez dans ce répertoire et lisez
<span class="emphasis"><em>attentivement</em></span> la documentation fournie. Il s'agit
généralement de fichiers nommés <code class="filename">README*</code>,
<code class="filename">INSTALL*</code>, <code class="filename">*.lsm</code> ou
<code class="filename">*.html</code>. Vous devez trouver les instructions pour
compiler et installer le programme (elles supposent très probablement que
vous voulez l'installer dans le répertoire
<code class="filename">/usr/local/bin</code> ; ce n'est pas le cas, mais ce point
sera traité plus tard en <a class="xref" href="modify.fr.html#destdir" title="3.3. Installation des fichiers à leur emplacement">Section 3.3, « Installation des fichiers à leur emplacement »</a>).
</p>
        <p>
Vous devriez commencer la création du paquet avec un répertoire source
complètement propre (originel), ou simplement avec les sources fraîchement
décompressées.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="simplemake"/>2.4. Systèmes de construction simples</h2>
            </div>
          </div>
        </div>
        <p>
Des programmes simples sont généralement fournis avec un fichier
<code class="filename">Makefile</code> et peuvent être compilés en appelant
simplement <code class="literal">make</code>. <a href="#ftn.idp38555008" class="footnote" id="idp38555008"><sup class="footnote">[11]</sup></a>
Certains d'entre eux gèrent <code class="literal">make check</code>, qui exécute des
vérifications internes. L'installation dans les répertoires de destination
se fait normalement avec <code class="literal">make install</code>.
</p>
        <p>
Maintenant, essayez de compiler et d'exécuter le programme, pour vous
assurer qu'il fonctionne correctement et ne casse rien d'autre quand il est
installé ou utilisé.
</p>
        <p>
Sachez aussi que vous pouvez généralement utiliser <code class="literal">make
clean</code> (ou mieux, <code class="literal">make distclean</code>) pour nettoyer
le répertoire de compilation. Parfois, <code class="literal">make uninstall</code>
peut être utilisé pour retirer tous les fichiers installés.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="portable"/>2.5. Systèmes de construction portables répandus</h2>
            </div>
          </div>
        </div>
        <p>
De nombreux logiciels libres sont écrits en <a class="ulink" href="http://fr.wikipedia.org/wiki/C_(langage)">C</a> et <a class="ulink" href="http://fr.wikipedia.org/wiki/C++">C++</a>. Beaucoup
d'entre eux utilisent les Autotools ou CMake pour les rendre portables sur
différentes architectures. Ces outils de construction doivent être utilisés
pour créer les <code class="filename">Makefile</code> et d'autres fichiers sources
nécessaires. Ensuite, de tels programmes sont construits en utilisant
l'habituel <code class="literal">make; make install</code>.
</p>
        <p>
Les <a class="ulink" href="http://fr.wikipedia.org/wiki/Autotools">Autotools</a> sont les outils de
construction GNU. Ils comprennent <a class="ulink" href="http://fr.wikipedia.org/wiki/Autoconf">Autoconf</a>,
<a class="ulink" href="http://fr.wikipedia.org/wiki/GNU_Automake">Automake</a>, <a class="ulink" href="http://fr.wikipedia.org/wiki/GNU_Libtool">Libtool</a> et <a class="ulink" href="http://fr.wikipedia.org/wiki/GNU_gettext">gettext</a>. Vous pouvez reconnaître de telles sources à
l'aide des fichiers <code class="filename">configure.ac</code>,
<code class="filename">Makefile.am</code> et
<code class="filename">Makefile.in</code>. <a href="#ftn.idp38591040" class="footnote" id="idp38591040"><sup class="footnote">[12]</sup></a>
</p>
        <p>
La première étape du travail des Autotools est généralement faite par les
auteurs amont qui exécutent <code class="literal">autoreconf -i -f</code> dans le
répertoire des sources et distribuent les fichiers créés avec les sources.
</p>
        <pre class="screen">
configure.ac-----+-&gt; autoreconf -+-&gt; configure
Makefile.am -----+        |      +-&gt; Makefile.in
src/Makefile.am -+        |      +-&gt; src/Makefile.in
                          |      +-&gt; config.h.in
                      automake
                      aclocal
                      aclocal.m4
                      autoheader
</pre>
        <p>
Modifier les fichiers <code class="filename">configure.ac</code> et
<code class="filename">Makefile.am</code> nécessite un peu de connaissance de
<span class="command"><strong>autoconf</strong></span> et <span class="command"><strong>automake</strong></span>. Consultez
<code class="literal">info autoconf</code> et <code class="literal">info automake</code>.
</p>
        <p>
La deuxième étape du travail des Autotools est habituellement que les
utilisateurs se procurent ces sources et exécutent <code class="literal">./configure
&amp;&amp; make</code> dans le répertoire des sources pour compiler le
programme en une commande exécutable
<span class="command"><strong><em class="replaceable"><code>binaire</code></em></strong></span>.
</p>
        <pre class="screen">
Makefile.in -----+                +-&gt; Makefile -----+-&gt; make -&gt; <em class="replaceable"><code>binaire</code></em>
src/Makefile.in -+-&gt; ./configure -+-&gt; src/Makefile -+
config.h.in -----+                +-&gt; config.h -----+
                 |
  config.status -+
  config.guess --+
</pre>
        <p>
Vous pouvez modifier plein de choses dans le fichier
<code class="filename">Makefile</code> ; vous pouvez, par exemple, modifier
l'emplacement par défaut du répertoire d'installation en utilisant la
commande <code class="literal">./configure --prefix=/usr</code>.
</p>
        <p>
Bien que ce ne soit pas nécessaire, mettre à jour
<code class="filename">configure</code> et les autres fichiers avec
<code class="literal">autoreconf -i -f</code> peut améliorer la compatibilité des
sources. <a href="#ftn.idp38604016" class="footnote" id="idp38604016"><sup class="footnote">[13]</sup></a>
</p>
        <p>
<a class="ulink" href="http://fr.wikipedia.org/wiki/CMake">CMake</a> est un système de construction
alternatif. De tels sources peuvent être reconnus avec le fichier
<code class="filename">CMakeLists.txt</code>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="namever"/>2.6. Nom et version de paquet</h2>
            </div>
          </div>
        </div>
        <p>
Si le code source amont est distribué sous le nom de
<code class="filename">gentoo-0.9.12.tar.gz</code>, vous pouvez prendre
<code class="literal">gentoo</code> comme <span class="strong"><strong>nom de
paquet</strong></span> (source) et <code class="literal">0.9.12</code> comme <span class="strong"><strong>version amont</strong></span>. Ces désignations seront aussi
utilisées dans le fichier <code class="filename">debian/changelog</code> décrit plus
loin dans <a class="xref" href="dreq.fr.html#changelog" title="4.3. changelog">Section 4.3, « <code class="filename">changelog</code> »</a>.
</p>
        <p>
Même si cette simple approche fonctionne la plupart du temps, vous pourriez
devoir remplacer <span class="strong"><strong>nom de paquet</strong></span> et
<span class="strong"><strong>version amont</strong></span> en renommant les sources
amont afin de suivre la Charte Debian et les conventions existantes.
</p>
        <p>
Le <span class="strong"><strong>nom de paquet</strong></span> ne doit contenir que des
lettres minuscules (<code class="literal">a-z</code>), des chiffres
(<code class="literal">0-9</code>), les signes plus (<code class="literal">+</code>) ou moins
(<code class="literal">-</code>) et des points (<code class="literal">.</code>). Il doit
comporter au moins deux caractères, commencer par un caractère
alphanumérique et ne doit pas être déjà utilisé. Il est préférable de garder
sa longueur inférieure à trente caractères. <a href="#ftn.idp38617392" class="footnote" id="idp38617392"><sup class="footnote">[14]</sup></a>
</p>
        <p>
Si l'amont utilise quelques termes génériques comme
<code class="literal">test-suite</code> comme nom, il vaut mieux les renommer pour
identifier son contenu de façon explicite et éviter de polluer l'espace de
nom. <a href="#ftn.idp38620480" class="footnote" id="idp38620480"><sup class="footnote">[15]</sup></a>
</p>
        <p>
La <span class="strong"><strong>version amont</strong></span> ne devrait contenir que
des caractères alphanumériques (<code class="literal">0-9A-Za-z</code>), plus
(<code class="literal">+</code>), tildes (<code class="literal">~</code>) et points
(<code class="literal">.</code>). Elle doit commencer par un chiffre
(<code class="literal">0-9</code>). <a href="#ftn.idp38625008" class="footnote" id="idp38625008"><sup class="footnote">[16]</sup></a> Il est
conseillé de garder sa longueur inférieure à huit caractères si
possible. <a href="#ftn.idp38625904" class="footnote" id="idp38625904"><sup class="footnote">[17]</sup></a>
</p>
        <p>
Si l'amont n'utilise pas un système d'affectation de version classique comme
<code class="literal">2.30.32</code> mais utilise plutôt une sorte de date comme
<code class="literal">11Apr29</code>, un nom de code aléatoire ou une somme de hachage
d'un système de gestion de versions dans la version, assurez-vous d'enlever
ces parties de la <span class="strong"><strong>version amont</strong></span>. Ces
renseignements peuvent être enregistrés dans le fichier
<code class="filename">debian/changelog</code>. Si vous devez inventer une version,
utilisez le format <code class="literal">AAAAMMJJ</code>, par exemple
<code class="literal">20110429</code>, comme numéro de version. Cela garantit que
<span class="command"><strong>dpkg</strong></span> interprète correctement les futures versions comme
des mises à niveau. Pour permettre des mises à niveau en douceur vers un
schéma de version classique comme <code class="literal">0.1</code> dans l'avenir,
utilisez plutôt la forme <code class="literal">0~AAMMJJ</code> comme
<code class="literal">0~110429</code> pour la version amont.
</p>
        <p>
Les chaînes de version <a href="#ftn.idp38634496" class="footnote" id="idp38634496"><sup class="footnote">[18]</sup></a> peuvent être
comparées en utilisant <span class="citerefentry"><span class="refentrytitle">dpkg</span>(1)</span> comme suit :
</p>
        <pre class="screen">
$ dpkg --compare-versions <em class="replaceable"><code>ver1</code></em> <em class="replaceable"><code>op</code></em> <em class="replaceable"><code>ver2</code></em>
</pre>
        <p>
La règle de comparaison de version peut être résumée par :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>les chaînes sont comparées en commençant par le début ;</p>
            </li>
            <li class="listitem">
              <p>les lettres sont plus grandes que les nombres ;</p>
            </li>
            <li class="listitem">
              <p>les nombres sont comparés comme des entiers ;</p>
            </li>
            <li class="listitem">
              <p>les lettres sont comparées dans l'ordre de leur code ASCII ;</p>
            </li>
            <li class="listitem">
              <p>des règles particulières sont appliquées pour les points
(<code class="literal">.</code>), plus (<code class="literal">+</code>) et tildes
(<code class="literal">~</code>) comme suit :</p>
              <p>
<code class="literal">0.0</code> &lt; <code class="literal">0.5</code> &lt;
<code class="literal">0.10</code> &lt; <code class="literal">0.99</code> &lt;
<code class="literal">1</code> &lt; <code class="literal">1.0~rc1</code> &lt;
<code class="literal">1.0</code> &lt; <code class="literal">1.0+b1</code> &lt;
<code class="literal">1.0+nmu1</code> &lt; <code class="literal">1.1</code> &lt;
<code class="literal">2.0</code>
</p>
            </li>
          </ul>
        </div>
        <p>
Un cas délicat se produit quand une version amont
<code class="filename">gentoo-0.9.12-ReleaseCandidate-99.tar.gz</code> est publiée
comme une préversion de <code class="filename">gentoo-0.9.12.tar.gz</code>. Vous
devez vous assurer que la mise à niveau fonctionne correctement en renommant
les sources amont en <code class="filename">gentoo-0.9.12~rc99.tar.gz</code>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="dh-make"/>2.7. Configuration de <span class="command"><strong>dh_make</strong></span></h2>
            </div>
          </div>
        </div>
        <p>
Configurez les variables d'environnement de l'interpréteur de commandes
<code class="literal">$DEBEMAIL</code> et <code class="literal">$DEBFULLNAME</code> de telle
sorte que plusieurs outils de maintenance Debian identifient l’adresse
électronique et le nom à utiliser pour les paquets : <a href="#ftn.idp38658304" class="footnote" id="idp38658304"><sup class="footnote">[19]</sup></a>
</p>
        <pre class="screen">
$ cat &gt;&gt;~/.bashrc &lt;&lt;EOF
DEBEMAIL="your.email.address@example.org"
DEBFULLNAME="Prénom Nom"
export DEBEMAIL DEBFULLNAME
EOF
$ . ~/.bashrc
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="non-native-dh-make"/>2.8. Paquet Debian non natif initial</h2>
            </div>
          </div>
        </div>
        <p>
Les paquets Debian normaux sont des paquets Debian non natifs réalisés à
partir de programmes amont. Pour créer un paquet Debian non natif à partir
d'une source amont <code class="filename">gentoo-0.9.12.tar.gz</code>, vous pouvez
lui créer un paquet Debian non natif initial en appelant la commande
<span class="command"><strong>dh_make</strong></span> comme suit :
</p>
        <pre class="screen">
$ cd ~/gentoo
$ wget http://www.example.org/gentoo-0.9.12.tar.gz
$ tar xvzf gentoo-0.9.12.tar.gz
$ cd gentoo-0.9.12
$ dh_make -f ../gentoo-0.9.12.tar.gz
</pre>
        <p>
Bien sûr, remplacez le nom de fichier par celui de votre archive source
d'origine. <a href="#ftn.idp38664416" class="footnote" id="idp38664416"><sup class="footnote">[20]</sup></a> Consultez <span class="citerefentry"><span class="refentrytitle">dh_make</span>(8)</span> pour plus de précisions.
</p>
        <p>
Vous devriez voir quelques questions sur le type de paquet vous voulez
créer. Gentoo est un paquet binaire simple — il ne crée qu'un paquet
binaire, c'est-à-dire un seul fichier <code class="filename">.deb</code> — donc la
première option sera sélectionnée (avec la touche <code class="literal">s</code>). Une
fois l'information vérifiée sur l'écran, confirmez en pressant
<code class="literal"><em class="replaceable"><code>Entrée</code></em></code>. <a href="#ftn.idp38671120" class="footnote" id="idp38671120"><sup class="footnote">[21]</sup></a>
</p>
        <p>
Cette exécution de <span class="command"><strong>dh_make</strong></span> crée une copie de l'archive
amont en <code class="filename">gentoo_0.9.12.orig.tar.gz</code> dans le répertoire
parent pour permettre ensuite la création d'un paquet source Debian non
natif nommé <code class="filename">debian.tar.gz</code> plus tard :
</p>
        <pre class="screen">
$ cd ~/gentoo ; ls -F
gentoo-0.9.12/
gentoo-0.9.12.tar.gz
gentoo_0.9.12.orig.tar.gz
</pre>
        <p>
Veuillez remarquer deux caractéristiques du nom de fichier
<code class="filename">gentoo_0.9.12.orig.tar.gz</code> :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
le nom de paquet et la version sont séparés par le caractère tiret bas
(<code class="literal">_</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
la chaîne <code class="filename">.orig</code> est insérée avant le
<code class="filename">.tar.gz</code>.
</p>
            </li>
          </ul>
        </div>
        <p>
Vous devriez aussi remarquer que de nombreux fichiers modèles sont créés
dans les sources sous le répertoire <code class="filename">debian</code>. Ce sera
expliqué en <a class="xref" href="dreq.fr.html" title="Chapitre 4. Fichiers nécessaires dans le répertoire debian">Chapitre 4, <em>Fichiers nécessaires dans le répertoire <code class="filename">debian</code></em></a> et <a class="xref" href="dother.fr.html" title="Chapitre 5. Autres fichiers dans le répertoire debian">Chapitre 5, <em>Autres fichiers dans le répertoire <code class="filename">debian</code></em></a>. Vous devriez
aussi comprendre que l'empaquetage ne peut pas être un processus
complètement automatisé. Vous aurez à modifier les sources amont pour Debian
(consultez <a class="xref" href="modify.fr.html" title="Chapitre 3. Modification du code source">Chapitre 3, <em>Modification du code source</em></a>). Après cela, vous devez utiliser les
méthodes correctes pour construire les paquets Debian (<a class="xref" href="build.fr.html" title="Chapitre 6. Construction du paquet">Chapitre 6, <em>Construction du paquet</em></a>), les vérifier (<a class="xref" href="checkit.fr.html" title="Chapitre 7. Contrôle des erreurs du paquet">Chapitre 7, <em>Contrôle des erreurs du paquet</em></a>) et les envoyer
(<a class="xref" href="upload.fr.html" title="Chapitre 9. Envoi de paquet">Chapitre 9, <em>Envoi de paquet</em></a>). Toutes ces étapes seront expliquées.
</p>
        <p>
Si vous effacez par mégarde quelques fichiers modèles en travaillant dessus,
vous pouvez les retrouver en exécutant de nouveau <span class="command"><strong>dh_make</strong></span>
avec l'option <code class="literal">--addmissing</code> dans une arborescence de
paquet Debian.
</p>
        <p>
La mise à jour d'un paquet existant peut devenir compliquée puisqu'il
pourrait utiliser d'anciennes techniques. Lors de l'apprentissage des bases,
veuillez vous en tenir aux cas d'empaquetage récent ; des explications sont
données plus loin en <a class="xref" href="update.fr.html" title="Chapitre 8. Mise à jour de paquet">Chapitre 8, <em>Mise à jour de paquet</em></a>.
</p>
        <p>
Veuillez noter que le fichier source ne doit pas forcément contenir de
système de construction comme en <a class="xref" href="first.fr.html#simplemake" title="2.4. Systèmes de construction simples">Section 2.4, « Systèmes de construction simples »</a> et <a class="xref" href="first.fr.html#portable" title="2.5. Systèmes de construction portables répandus">Section 2.5, « Systèmes de construction portables répandus »</a>. Il peut simplement s'agir d'un ensemble de données
graphiques par exemple. L'installation de fichiers peut être effectuée en
utilisant juste les fichiers de configuration de <code class="systemitem">debhelper</code> comme
<code class="filename">debian/install</code> (consultez <a class="xref" href="dother.fr.html#install" title="5.11. install">Section 5.11, « <code class="filename">install</code> »</a>).
</p>
      </div>
      <div class="footnotes">
        <br/>
        <hr/>
        <div id="ftn.idp38423440" class="footnote">
          <p><a href="#idp38423440" class="para"><sup class="para">[4] </sup></a>Les paquets source Debian non natifs au style plus ancien de format
<code class="literal">1.0</code> utilisent à la place
<code class="literal"><em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>-<em class="replaceable"><code>révision</code></em>.diff.gz</code>. </p>
        </div>
        <div id="ftn.idp38440064" class="footnote">
          <p><a href="#idp38440064" class="para"><sup class="para">[5] </sup></a> Consultez <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-controlfields.html#s-f-Source">5.6.1 « Source »</a>, <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-controlfields.html#s-f-Package">5.6.7 « Paquet »</a> et <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-controlfields.html#s-f-Version">5.6.12 « Version »</a>. L'<span class="strong"><strong>architecture du paquet</strong></span> doit suivre la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-controlfields.html#s-f-Architecture">Charte Debian, 5.6.8 « Architecture »</a> et
est automatiquement attribuée par le processus de construction du paquet.</p>
        </div>
        <div id="ftn.idp38454432" class="footnote">
          <p><a href="#idp38454432" class="para"><sup class="para">[6] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/manuals/developers-reference/pkgs.html#adopting">référence du Développeur Debian
5.9.5. « Adoption de paquet »</a>.</p>
        </div>
        <div id="ftn.idp38467536" class="footnote">
          <p><a href="#idp38467536" class="para"><sup class="para">[7] </sup></a> Cela dit, il existera toujours des paquets qui vaudront la peine d'être
empaquetés.  </p>
        </div>
        <div id="ftn.idp38521664" class="footnote">
          <p><a href="#idp38521664" class="para"><sup class="para">[8] </sup></a>Ne vous inquiétez pas du <code class="filename">Makefile</code> manquant. Vous pouvez
installer la commande <span class="command"><strong>hello</strong></span> en utilisant simplement
<span class="command"><strong>debhelper</strong></span> comme en <a class="xref" href="dother.fr.html#install" title="5.11. install">Section 5.11, « <code class="filename">install</code> »</a>, ou en
modifiant le source amont pour ajouter un nouveau
<code class="filename">Makefile</code> avec la cible <code class="literal">install</code> comme
en <a class="xref" href="modify.fr.html" title="Chapitre 3. Modification du code source">Chapitre 3, <em>Modification du code source</em></a>.</p>
        </div>
        <div id="ftn.idp38537072" class="footnote">
          <p><a href="#idp38537072" class="para"><sup class="para">[9] </sup></a> Vous pouvez identifier le format de l'archive en utilisant la commande
<span class="command"><strong>file</strong></span> si l'extension du fichier ne suffit pas.  </p>
        </div>
        <div id="ftn.idp38540816" class="footnote">
          <p><a href="#idp38540816" class="para"><sup class="para">[10] </sup></a> Ce programme est déjà empaqueté. La <a class="ulink" href="http://packages.qa.debian.org/g/gentoo.html">version
actuelle</a> utilise Autotools comme structure de construction et est
substantiellement différente des exemples suivants qui étaient basés sur la
version 0.9.12.</p>
        </div>
        <div id="ftn.idp38555008" class="footnote">
          <p><a href="#idp38555008" class="para"><sup class="para">[11] </sup></a>
Beaucoup de programmes récents sont livrés avec un script
<code class="filename">configure</code> qui crée un fichier
<code class="filename">Makefile</code> personnalisé pour le système au moment de son
exécution.</p>
        </div>
        <div id="ftn.idp38591040" class="footnote">
          <p><a href="#idp38591040" class="para"><sup class="para">[12] </sup></a>Les Autotools sont trop importants pour être traités dans ce petit
tutoriel. Cette section a seulement pour but de fournir les mots-clefs et
les références. Veuillez vous assurer d'avoir lu le <a class="ulink" href="http://www.lrde.epita.fr/~adl/autotools.html">tutoriel des Autotools</a> et la copie locale
de <code class="filename">/usr/share/doc/autotools-dev/README.Debian.gz</code> si vous avez besoin de les
utiliser.</p>
        </div>
        <div id="ftn.idp38604016" class="footnote">
          <p><a href="#idp38604016" class="para"><sup class="para">[13] </sup></a>Vous pouvez automatiser ce processus en utilisant le paquet <code class="systemitem">dh-autoreconf</code>. Consultez <a class="xref" href="dreq.fr.html#customrules" title="4.4.3. Personnalisation du fichier rules">Section 4.4.3, « Personnalisation du fichier <code class="filename">rules</code> »</a>.</p>
        </div>
        <div id="ftn.idp38617392" class="footnote">
          <p><a href="#idp38617392" class="para"><sup class="para">[14] </sup></a>La longueur par défaut du champ de nom de paquet dans
<span class="command"><strong>aptitude</strong></span> est de 30 caractères. Plus de 90 % des paquets
ont un nom de paquet inférieur à 24 caractères.</p>
        </div>
        <div id="ftn.idp38620480" class="footnote">
          <p><a href="#idp38620480" class="para"><sup class="para">[15] </sup></a>Si vous suivez la <a class="ulink" href="http://www.debian.org/doc/developers-reference/pkgs.html#newpackage">référence du Développeur
Debian 5.1. « Nouveaux paquets »</a>, le processus d'ITP devrait
permettre de se rendre compte de ce genre de problèmes.</p>
        </div>
        <div id="ftn.idp38625008" class="footnote">
          <p><a href="#idp38625008" class="para"><sup class="para">[16] </sup></a>Cette règle plus stricte devrait permettre d'éviter toute confusion de noms
de fichier.</p>
        </div>
        <div id="ftn.idp38625904" class="footnote">
          <p><a href="#idp38625904" class="para"><sup class="para">[17] </sup></a>La longueur par défaut du champ de version dans <span class="command"><strong>aptitude</strong></span>
est de 10 caractères. La révision Debian précédée par un tiret en utilise au
moins 2. Plus de 80 % des paquets ont une version amont inférieure à
8 caractères et une révision Debian inférieure à 2 caractères. Plus de 90 %
des paquets ont une version amont inférieure à 10 caractères et une révision
Debian inférieure à 3 caractères.</p>
        </div>
        <div id="ftn.idp38634496" class="footnote">
          <p><a href="#idp38634496" class="para"><sup class="para">[18] </sup></a>Les chaînes de version peuvent être <span class="strong"><strong>version
amont</strong></span> (<code class="literal"><em class="replaceable"><code>version</code></em></code>),
<span class="strong"><strong>révision Debian</strong></span>
(<code class="literal"><em class="replaceable"><code>révision</code></em></code>) ou <span class="strong"><strong>version</strong></span>
(<code class="literal"><em class="replaceable"><code>version</code></em></code>-<code class="literal"><em class="replaceable"><code>révision</code></em></code>).
Consultez <a class="xref" href="update.fr.html#newrevision" title="8.1. Nouvelle révision Debian">Section 8.1, « Nouvelle révision Debian »</a> pour la façon dont la <span class="strong"><strong>révision Debian</strong></span> est incrémentée.
</p>
        </div>
        <div id="ftn.idp38658304" class="footnote">
          <p><a href="#idp38658304" class="para"><sup class="para">[19] </sup></a> Le texte qui suit présuppose que l'interpréteur de commandes que vous
utilisez à la connexion est Bash. Si vous utilisez un autre interpréteur de
commandes, par exemple zsh, il est nécessaire d'utiliser le fichier de
configuration correspondant au lieu de <code class="filename">~/.bashrc</code>. </p>
        </div>
        <div id="ftn.idp38664416" class="footnote">
          <p><a href="#idp38664416" class="para"><sup class="para">[20] </sup></a> Si les sources amont fournissent le répertoire <code class="filename">debian</code>
et son contenu, exécutez la commande <span class="command"><strong>dh_make</strong></span> avec
l'option supplémentaire <code class="literal">--addmissing</code>. Le nouveau format
source <code class="literal">3.0 (quilt)</code> est suffisamment robuste pour ne pas
casser même avec ces paquets. Vous pourriez avoir besoin de mettre à jour le
contenu fourni en amont pour votre paquet Debian.  </p>
        </div>
        <div id="ftn.idp38671120" class="footnote">
          <p><a href="#idp38671120" class="para"><sup class="para">[21] </sup></a> Il y a plusieurs choix à ce moment : <code class="literal">s</code> pour un seul
paquet binaire, <code class="literal">i</code> pour un paquet binaire indépendant de
l'architecture, <code class="literal">m</code> pour plusieurs paquets binaires,
<code class="literal">l</code> pour un paquet de bibliothèque, <code class="literal">k</code>
pour un paquet de module du noyau, <code class="literal">n</code> pour un paquet de
correctif du noyau et <code class="literal">b</code> pour un paquet <code class="systemitem">cdbs</code>. Ce document se concentre sur l'utilisation
de la commande <span class="command"><strong>dh</strong></span> (du paquet <code class="systemitem">debhelper</code>) pour créer un seul paquet binaire,
mais effleure aussi son utilisation pour les paquets binaires indépendants
de l'architecture ou de plusieurs paquets binaires. Le paquet <code class="systemitem">cdbs</code> propose une autre infrastructure de scripts
de paquet que la commande <span class="command"><strong>dh</strong></span> et sort du cadre de ce
document.  </p>
        </div>
      </div>
    </div>
    <div class="navfooter">
      <hr/>
      <table width="100%" summary="Navigation footer">
        <tr>
          <td align="left"><a accesskey="p" href="start.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <td align="center"> </td>
          <td align="right"> <a accesskey="n" href="modify.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
        <tr>
          <td align="left" valign="top">Chapitre 1. Partir du bon pied </td>
          <td align="center">
            <a accesskey="h" href="index.fr.html">
              <img src="images/home.png" alt="Sommaire"/>
            </a>
          </td>
          <td align="right" valign="top"> Chapitre 3. Modification du code source</td>
        </tr>
      </table>
    </div>
  </body>
</html>
